<template>
  <component
    :is="tag"
    class="ui-poligon uikit-select-none uppercase uikit-text-center"
    :class="classList"
  >
    <div
      class="wrapper inline-block uikit-relative aspect-1 uikit-font-title overflow-hidden"
      :style="styleList"
    >
      <svg
        class="svg uikit-w-full uikit-h-full"
        width="64"
        height="64"
        viewBox="0 0 64 64"
        fill="none"
        xmlns="http://www.w3.org/2000/svg"
      >
        <path
          fill-rule="evenodd"
          clip-rule="evenodd"
          :d="d"
          fill="currentColor"
        />
      </svg>
      <div class="content uikit-absolute uikit-inset-0 z-0 uikit-flex uikit-justify-center uikit-items-center">
        <slot />
      </div>
    </div>
  </component>
</template>

<script lang="ts">
  import { defineComponent, computed, PropType } from 'vue'
  import { UI_POLIGON_BUTTON_VARIANTS } from './constants'
  import type { UiPoligonVariantProp } from './types'

  export default defineComponent({
    inheritAttrs: true,
    props: {
      tag: {
        type: String,
        default: 'div',
      },
      size: {
        type: Number,
        default: 50,
      },
      corners: {
        type: Number,
        default: 12,
        validator: (val: 12|6) => ['12', '6'].includes(val.toString()),
      },
      variant: {
        type: String as PropType<UiPoligonVariantProp>,
        validator: (value: UiPoligonVariantProp) => UI_POLIGON_BUTTON_VARIANTS.includes(value),
        default: 'green-original',
      },
      opacity: {
        type: Boolean,
        default: false,
      },
      animated: {
        type: Boolean,
        default: false,
      },
    },
    setup(props) {
      const d = computed(() => {
        return props.corners == 6
          ? 'M32 0L59.7128 16V48L32 64L4.28719 48V16L32 0Z'
          : 'M32 0L48 4.28719L59.7128 16L64 32L59.7128 48L48 59.7128L32 64L16 59.7128L4.28719 48L0 32L4.28719 16L16 4.28719L32 0Z'
      })
      const classList = computed(() => {
        return {
          '-animated': props.animated,
          '-opacity': props.opacity,
          'cursor-default': props.tag === 'div',
          [`-${props.variant}`]: true,
        }
      })
      const styleList = computed(() => {
        const size = `${props.size}px`

        return {
          width: size,
          height: size,
        }
      })

      return { classList, styleList, d }
    },
  })
</script>

<style>
  .ui-poligon {
    @apply uikit-text-12;
  }

  .ui-poligon.-opacity > .wrapper > .svg {
    @apply uikit-opacity-30;
  }

  .ui-poligon.-animated > .wrapper > .svg {
    animation: ui-poligon-spin 30s linear infinite;
  }

  .ui-poligon.-default > .wrapper > .content {
    @apply uikit-text-black;
  }

  .ui-poligon.-green-atomic > .wrapper {
    @apply uikit-text-green-atomic;
  }
  .ui-poligon.-green-atomic > .wrapper > .content {
    @apply uikit-text-black;
  }

  .ui-poligon.-violet > .wrapper {
    @apply uikit-text-violet;
  }
  .ui-poligon.-violet > .wrapper > .content {
    @apply uikit-text-white;
  }

  .ui-poligon.-white > .wrapper {
    @apply uikit-text-white;
  }
  .ui-poligon.-white > .wrapper > .content {
    @apply uikit-text-black;
  }

  .ui-poligon.-green-original > .wrapper {
    @apply uikit-text-green-original;
  }
  .ui-poligon.-green-original > .wrapper > .content {
    @apply uikit-text-black;
  }

  .ui-poligon.-yellow > .wrapper {
    @apply uikit-text-yellow;
  }
  .ui-poligon.-yellow > .wrapper > .content {
    @apply uikit-text-black;
  }

  .ui-poligon.-red > .wrapper {
    @apply uikit-text-red;
  }
  .ui-poligon.-red > .wrapper > .content {
    @apply uikit-text-white;
  }

  .ui-poligon.-orange > .wrapper {
    @apply uikit-text-orange;
  }
  .ui-poligon.-orange > .wrapper > .content {
    @apply uikit-text-white;
  }

  @keyframes ui-poligon-spin {
    from {
      transform: rotate(0deg);
    }
    to {
      transform: rotate(360deg);
    }
  }
</style>
